package com.drinkertea.test2smack;

import androidx.annotation.NonNull;
import androidx.appcompat.app.AppCompatActivity;
import androidx.core.app.ActivityCompat;
import androidx.core.content.ContextCompat;

import android.Manifest;
import android.app.Activity;
import android.app.Dialog;
import android.app.ProgressDialog;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.os.Bundle;
import android.os.Handler;
import android.view.View;
import android.widget.EditText;

import com.dcastalia.localappupdate.DownloadApk;

import org.jivesoftware.smack.AbstractXMPPConnection;
import org.jivesoftware.smack.MessageListener;
import org.jivesoftware.smack.XMPPConnection;
import org.jivesoftware.smack.chat2.Chat;
import org.jivesoftware.smack.chat2.ChatManager;
import org.jivesoftware.smack.chat2.IncomingChatMessageListener;
import org.jivesoftware.smack.packet.Message;
import org.jivesoftware.smack.packet.Presence;
import org.jivesoftware.smack.roster.Roster;
import org.jivesoftware.smack.roster.RosterEntry;
import org.jivesoftware.smackx.mam.MamManager;
import org.jivesoftware.smackx.muc.HostedRoom;
import org.jivesoftware.smackx.muc.InvitationListener;
import org.jivesoftware.smackx.muc.MultiUserChat;
import org.jivesoftware.smackx.muc.MultiUserChatManager;
import org.jivesoftware.smackx.muc.packet.MUCUser;
import org.jxmpp.jid.DomainBareJid;
import org.jxmpp.jid.EntityBareJid;
import org.jxmpp.jid.EntityFullJid;
import org.jxmpp.jid.EntityJid;
import org.jxmpp.jid.impl.JidCreate;
import org.jxmpp.jid.parts.Resourcepart;

import java.util.Collection;
import java.util.List;
import java.util.Map;
import java.util.Timer;
import java.util.TimerTask;


public class MainActivity extends AppCompatActivity {

    private EditText ETemail;
    private EditText ETpassword;
    String email;
    String password;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        ETemail = (EditText) findViewById(R.id.ETEmail);
        ETpassword = (EditText) findViewById(R.id.ETPassword);
    }

    public void RunService(){
        if(!NotificationService.serverIsWorked){
            startService(new Intent(this, NotificationService.class));
        }
        else {
            System.out.println("Server work!");
        }
    }

    public void goToPageWithChats(View view){
        try {
            email = ETemail.getText().toString();
            password = ETpassword.getText().toString();
            //Авторизация
            boolean isLogin = XMPPClass.XMPP_Connection(email, password);
            //Переход и заупск сервера
            if (isLogin && XMPPClass.connection.getUser() != null){
                RunService();
                Intent intent = new Intent(this, ChatsList.class);
                startActivity(intent);
            }
            else {
                System.out.println("Error connect!");
            }
        }catch (Exception ex){
            System.out.println(ex.getMessage());
        }
    }

    public void testMethod(View view) throws Exception{
        email = ETemail.getText().toString();
        password = ETpassword.getText().toString();
        boolean isLogin = XMPPClass.XMPP_Connection(email, password);

        if (isLogin && XMPPClass.connection.getUser() != null){
            try {
                RunService();
                Intent intent = new Intent(this, rooms.class);
                startActivity(intent);
            }catch (Exception ex){
                System.out.println(ex.getMessage());
            }
        }
        else {
            System.out.println("Error connect!");
        }
    }

    public void stopNotificationClick(View view) throws Exception{
        stopService(new Intent(this, NotificationService.class));
    }

    public void updateApp(View view) throws Exception{
        String[] permissions = {Manifest.permission.WRITE_EXTERNAL_STORAGE, Manifest.permission.REQUEST_INSTALL_PACKAGES};
        if (ContextCompat.checkSelfPermission(this, Manifest.permission.WRITE_EXTERNAL_STORAGE) ==
                PackageManager.PERMISSION_GRANTED){
            String BASEURL = "https://github.com/WorldOfPets/test_apk_file/raw/master/app-debug.apk";
            DownloadApk downloadApk = new DownloadApk(MainActivity.this);
            downloadApk.startDownloadingApk(BASEURL);
        } else {
            ActivityCompat.requestPermissions(
                this,
                permissions,
                1
            );
        }
    }

    @Override
    public void onRequestPermissionsResult(int requestCode, @NonNull String[] permissions, @NonNull int[] grantResults) {
        super.onRequestPermissionsResult(requestCode, permissions, grantResults);
    }
}
