package com.drinkertea.test2smack;

import androidx.appcompat.app.AppCompatActivity;
import androidx.recyclerview.widget.RecyclerView;

import android.graphics.Color;
import android.graphics.Typeface;
import android.graphics.drawable.GradientDrawable;
import android.os.Bundle;
import android.view.View;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.TextView;

import org.jivesoftware.smack.MessageListener;
import org.jivesoftware.smack.chat2.Chat;
import org.jivesoftware.smack.chat2.ChatManager;
import org.jivesoftware.smack.chat2.IncomingChatMessageListener;
import org.jivesoftware.smack.packet.Message;
import org.jivesoftware.smackx.muc.MultiUserChat;
import org.jxmpp.jid.EntityBareJid;

import java.util.List;

public class Room extends AppCompatActivity {

    public LinearLayout roomLayout;
    public EditText roomMessageET;
    public MultiUserChat thisMuc = XMPPClass.activeMuc;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_room);
        roomMessageET = (EditText) findViewById(R.id.roomMessageView);
        roomLayout = (LinearLayout) findViewById(R.id.roomLayout);
        List<Message> messages = XMPPClass.CreateRoomListMessage(10, thisMuc);
        for(Message message : messages){
            String from = message.getFrom().asBareJid().toString().trim();
            if (from.equals(XMPPClass.myJid.asEntityBareJidString().trim())){
                addMessage(message.getFrom().toString().split("/")[1], message.getBody(), false);
            }
            else {
                addMessage(message.getFrom().toString().split("/")[1], message.getBody(), true);
            }
        }
        runMessageListener();
    }

    public void addMessage(String from, String body, boolean black){
        TextView fromName = new TextView(this);
        TextView bodyView = new TextView(this);
        LinearLayout linearLayout = new LinearLayout(this);

        fromName.setText(from + ": ");
        fromName.setTextSize(16);
        fromName.setTypeface(null, Typeface.BOLD);
        if (black){
            fromName.setTextColor(Color.parseColor("#000000"));
        } else {
            fromName.setTextColor(Color.parseColor("#006000"));
        }

        bodyView.setText(body);
        bodyView.setTextSize(14);
        bodyView.setTextColor(Color.parseColor("#000000"));
        linearLayout.setOrientation(LinearLayout.VERTICAL);
        linearLayout.addView(fromName);
        linearLayout.addView(bodyView);

        roomLayout.addView(linearLayout);
    }
    public void runMessageListener(){
        thisMuc.addMessageListener(new MessageListener() {
            @Override
            public void processMessage(Message message) {
                runOnUiThread(new Runnable() {
                    @Override
                    public void run() {
                        if (message.getBody() != null && message.getBody() != ""){
                            addMessage(message.getFrom().toString().split("/")[1], message.getBody(), true);
                        }

                        //System.out.println("New message from:" + from + ": " + message.toXML().toString());
                    }
                });
            }
        });
    }

    public void sendMessage(View view) {
        try {
            String text = roomMessageET.getText().toString();
            thisMuc.sendMessage(text);
            addMessage(XMPPClass.myJid.asBareJid().toString(), text, false);
            roomMessageET.setText("");
        }catch (Exception e){
            System.out.println(e.getMessage());
        }

    }
}